<template>
    <div class="composite">
        <!-- <ob-modal
            ref="modal-error"
            :title="'Ошибка на сервере'"
            :isShowControls="true"
            :isReadOnly="true"
        >
        </ob-modal>
        <ob-modal
            ref="modal-success"
            :title="'Данные сохранены'"
            :isShowControls="true"
            :isReadOnly="true"
        > -->
        <ob-form
            :isSubmitDisabled="formValid"
            :isCancelDisabled="formValid"
            @submit="save"
            @cancel="cancel"
            :cancelText="'Исходные'"
            :formData="indexFormData"
            ref="form"
        >
            <template slot="title">
                <strong>Настройка параметров индекса</strong>
            </template>
            <div>
                <ob-input
                    class="edit-method"
                    :label="'Предиктор роста'"
                    :placeholder="'Введите'"
                    type="text"
                    v-model="indexFormData.growthPredictor"
                    :mask="'9999'"
                />
                <ob-input
                    class="edit-method"
                    :label="'Предиктор убывания'"
                    :placeholder="'Введите'"
                    type="text"
                    v-model="indexFormData.decreasingPredictor"
                    :mask="'9999'"
                />
                <ob-input
                    class="edit-method"
                    :label="'Прирост по заказу'"
                    :placeholder="'Введите'"
                    type="text"
                    v-model="indexFormData.orderIncrease"
                    :mask="'9.9'"
                    isMasked
                />
                <ob-input
                    class="edit-method"
                    :label="'Максимальное значение предиктора'"
                    :placeholder="maxPredictor"
                    type="text"
                    disabled
                />
            </div>
        </ob-form>
    </div>
</template>

<script>
import ObForm from "common-components/src/obComponents/obForm";
import ObInput from "common-components/src/obComponents/obInput";
// import ObModal from 'common-components/src/obComponents/obModal';
import { GET_INDEX } from '../../store/modules/index_settings'
import { UPDATE_INDEX } from '../../store/modules/index_settings'

export default {
    data() {
        return {
            indexFormData: {
                growthPredictor: 0,
                decreasingPredictor: 0,
                orderIncrease: 0,
                predictorMaxValue: 0
            }
        }
    },
    components: {
        ObForm,
        ObInput,
        // ObModal
    },
    methods: {
        save() {
            const payload = {
                growthPredictor: this.indexFormData.growthPredictor,
                decreasingPredictor: this.indexFormData.decreasingPredictor,
                orderIncrease: this.indexFormData.orderIncrease
            }
            try {
                this.$store.dispatch(UPDATE_INDEX, payload)
                console.log('payload')
                console.log(payload)
                this.$refs['modal-success'].open();
            } catch (ex) {
                console.log(ex)
                this.$refs['modal-error'].open();
            }
            console.log('saved')
        },
        cancel() {
            console.log(this.formValid);
            this.updateForm(this.index);
        },
        updateForm(index) {
            this.indexFormData.growthPredictor = index.growthPredictor;
            this.indexFormData.decreasingPredictor = index.decreasingPredictor;
            this.indexFormData.orderIncrease = index.orderIncrease;
            this.$refs.form.resetForm();
            console.log("indexFormData")
            console.log(this.indexFormData)
        }
    },
    computed: {
        index() {
            return this.$store.getters.getIndexSettings;
        },
        formValid() {
            let val = this.index
            console.log('formValid')
            console.log(this.indexFormData)
            console.log(this.index)
            return +this.indexFormData.growthPredictor === (val && val.growthPredictor) &&
                +this.indexFormData.decreasingPredictor === (val && val.decreasingPredictor) &&
                +this.indexFormData.orderIncrease === (val && val.orderIncrease)
        },
        maxPredictor () {
          return (+this.indexFormData.growthPredictor + +this.indexFormData.decreasingPredictor).toString()
        }
    },
    async created() {
        await this.$store.dispatch(GET_INDEX)
    },
    watch: {
        index: function (val) {
            if (val) {
                console.log('index')
                console.log(val)
                this.updateForm(val);
            } else {
                throw new Error()
            }
        },
    }
}
</script>

<style lang="scss" scoped>
.composite {
    width: 50%;
    border-radius: 3px !important;
    -webkit-border-radius: 3px !important;
    -moz-border-radius: 3px !important;
    padding: 20px;
    background-color: white;
}
.edit-method {
//   display: flex;
//   padding: 10px 0;
//   justify-content: space-between;
    margin: 10px 0;

    &__label {
        padding-right: 10px;
    }
    &__input {
        margin: 0;
        width: 30%;
    }
}
</style>
